//+------------------------------------------------------------------+
//|                                                    SAInpData.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property description "Data for Spectrum Analyzer"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot Level0
#property indicator_label1  "Data"
#property indicator_type1   DRAW_LINE
#property indicator_color1  DodgerBlue
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- indicator buffers
double         DataBuffer[];

input bool Automatic=true;//
input int Window=0;       // 
input int Indicator=0;    // 

int Impulse=0;//  
int Handle=0; //  
int Kernel=0; //  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,DataBuffer,INDICATOR_DATA);

   Impulse=iCustom(NULL,0,"SpecAnalyzer\\Impulse");//   
   if(Impulse==INVALID_HANDLE)// 
     {
      Alert("  Impulse"); return(INIT_FAILED);
     }
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---  
   IndicatorRelease(Impulse);
   IndicatorRelease(Handle);
   IndicatorRelease(Kernel);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//-------------------------------------------  
   static bool Flag=false;// 
   if(Flag) return(rates_total);// ,  

//---  
   string Name;  //   
   if(!Automatic)//  
     {
      if(ChartIndicatorsTotal(0,Window)>0)//  
        {
         Name=ChartIndicatorName(0,Window,Indicator);//  
         Handle=ChartIndicatorGet(0,Window,Name);// 
        }
      else//
        {
         Alert(" ");
         Flag=true;
         return(rates_total);
        }

      if(Handle==INVALID_HANDLE)//   
        {
         Alert(" ");
         Flag=true;
         return(rates_total);
        }

      CopyBuffer(Handle,0,0,1024,DataBuffer);//   
      return(rates_total);
     }

//---  
//---  
   if(ChartIndicatorsTotal(0,0)>0)//     
     {
      Name=ChartIndicatorName(0,0,0);//  
      if(Name!="SpecAnalyzer")//   SpecAnalyzer
         Handle=ChartIndicatorGet(0,0,Name);// 
      else
        {
         Alert("  ");
         Flag=true;
         return(rates_total);
        }
     }
   else//
   if(ChartIndicatorsTotal(0,1)>0)//    
     {
      Name=ChartIndicatorName(0,1,0);//  
      if(Name!="SAInpData")//   SAInpData
         Handle=ChartIndicatorGet(0,1,Name);// 
      else//
        {
         Alert("  ");
         Flag=true;
         return(rates_total);
        }
     }

   if(Handle==INVALID_HANDLE)//   
     {
      Alert(" ");
      Flag=true;
      return(rates_total);
     }

//---  
   ENUM_INDICATOR indicator_type;//  
   MqlParam parameters[];// 
   int parameters_cnt=0;// 

                        //  ,     
   parameters_cnt=IndicatorParameters(Handle,indicator_type,parameters);
//--- ,        
   parameters[parameters_cnt-1].integer_value=Impulse;
//---       -  
   Kernel=IndicatorCreate(NULL,0,indicator_type,parameters_cnt,parameters);

   if(Kernel==INVALID_HANDLE)//   
     {
      Alert("  Kernel");
      Flag=true;
      return(rates_total);
     }

   CopyBuffer(Kernel,0,0,1024,DataBuffer);//   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
